Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class SignatureSpi

    java.lang.Object
      |
      +--java.security.SignatureSpi

Direct Known Subclasses:
  Signature

public abstract class SignatureSpi
extends Object

This class defines the Service Provider Interface (SPI) for the `Signature` class, which is used to provide the functionality of a digital signature algorithm. Digital signatures are used for authentication and integrity assurance of digital data. .

All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a particular signature algorithm.

See Also:
  `Signature`

Field Summary
`protected SecureRandom` | `appRandom` Application-specified source of randomness.

Constructor Summary
`SignatureSpi()`

Method Summary
`Object` | `clone()` Returns a clone if the implementation is cloneable.
`protected abstract void` | `engineInitSign(PrivateKey privateKey)` Initializes this signature object with the specified private key for signing operations.
`protected void` | `engineInitSign(PrivateKey privateKey, SecureRandom random)` Initializes this signature object with the specified private key and source of randomness for signing operations.
`protected abstract void` | `engineInitVerify(PublicKey publicKey)` Initializes this signature object with the specified public key for verification operations.
`protected void` | `engineSetParameter(AlgorithmParameterSpec params)` Initializes this signature engine with the specified parameter set.
`protected abstract byte[]` | `engineSign()` Returns the signature bytes of all the data updated so far.
`protected int` | `engineSign(byte[] outbuf, int offset, int len)` Finishes this signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`.
`protected abstract void` | `engineUpdate(byte b)` Updates the data to be signed or verified using the specified byte.
`protected abstract void` | `engineUpdate(byte[] b, int off, int len)` Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.
`protected abstract boolean` | `engineVerify(byte[] sigBytes)` Verifies the passed-in signature.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### appRandom

    protected SecureRandom appRandom

  Application-specified source of randomness.

Constructor Detail

### SignatureSpi

    public SignatureSpi()

Method Detail

### engineInitVerify

    protected abstract void engineInitVerify(PublicKey publicKey)
                                      throws InvalidKeyException

  Initializes this signature object with the specified public key for verification operations.
  Parameters:
    `publicKey` - the public key of the identity whose signature is going to be verified.
  Throws:
    `InvalidKeyException` - if the key is improperly encoded, parameters are missing, and so on.

### engineInitSign

    protected abstract void engineInitSign(PrivateKey privateKey)
                                    throws InvalidKeyException

  Initializes this signature object with the specified private key for signing operations.
  Parameters:
    `privateKey` - the private key of the identity whose signature will be generated.
  Throws:
    `InvalidKeyException` - if the key is improperly encoded, parameters are missing, and so on.

### engineInitSign

    protected void engineInitSign(PrivateKey privateKey,
                                  SecureRandom random)
                           throws InvalidKeyException

  Initializes this signature object with the specified private key and source of randomness for signing operations.

  This concrete method has been added to this previously-defined abstract class. (For backwards compatibility, it cannot be abstract.)

  Parameters:
    `privateKey` - the private key of the identity whose signature will be generated.
    `random` - the source of randomness
  Throws:
    `InvalidKeyException` - if the key is improperly encoded, parameters are missing, and so on.

### engineUpdate

    protected abstract void engineUpdate(byte b)
                                  throws SignatureException

  Updates the data to be signed or verified using the specified byte.
  Parameters:
    `b` - the byte to use for the update.
  Throws:
    `SignatureException` - if the engine is not initialized properly.

### engineUpdate

    protected abstract void engineUpdate(byte[] b,
                                         int off,
                                         int len)
                                  throws SignatureException

  Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.
  Parameters:
    `data` - the array of bytes.
    `off` - the offset to start from in the array of bytes.
    `len` - the number of bytes to use, starting at offset.
  Throws:
    `SignatureException` - if the engine is not initialized properly.

### engineSign

    protected abstract byte[] engineSign()
                                  throws SignatureException

  Returns the signature bytes of all the data updated so far. The format of the signature depends on the underlying signature scheme.
  Returns:
    the signature bytes of the signing operation's result.
  Throws:
    `SignatureException` - if the engine is not initialized properly.

### engineSign

    protected int engineSign(byte[] outbuf,
                             int offset,
                             int len)
                      throws SignatureException

  Finishes this signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`. The format of the signature depends on the underlying signature scheme.

  The signature implementation is reset to its initial state (the state it was in after a call to one of the `engineInitSign` methods) and can be reused to generate further signatures with the same private key. This method should be abstract, but we leave it concrete for binary compatibility. Knowledgeable providers should override this method.

  Parameters:
    `outbuf` - buffer for the signature result.
    `offset` - offset into `outbuf` where the signature is stored.
    `len` - number of bytes within `outbuf` allotted for the signature. Both this default implementation and the SUN provider do not return partial digests. If the value of this parameter is less than the actual signature length, this method will throw a SignatureException. This parameter is ignored if its value is greater than or equal to the actual signature length.
  Returns:
    the number of bytes placed into `outbuf`
  Throws:
    `SignatureException` - if an error occurs or `len` is less than the actual signature length.
  Since:
    1.2

### engineVerify

    protected abstract boolean engineVerify(byte[] sigBytes)
                                     throws SignatureException

  Verifies the passed-in signature.
  Parameters:
    `sigBytes` - the signature bytes to be verified.
  Returns:
    true if the signature was verified, false if not.
  Throws:
    `SignatureException` - if the engine is not initialized properly, or the passed-in signature is improperly encoded or of the wrong type, etc.

### engineSetParameter

    protected void engineSetParameter(AlgorithmParameterSpec params)
                               throws InvalidAlgorithmParameterException

  Initializes this signature engine with the specified parameter set. This concrete method has been added to this previously-defined abstract class. (For backwards compatibility, it cannot be abstract.) It may be overridden by a provider to set the algorithm parameters using the specified `params`. Such an override is expected to throw an InvalidAlgorithmParameterException if a parameter is invalid. If this method is not overridden, it always throws an UnsupportedOperationException. param params the parameters exception InvalidAlgorithmParameterException if the given parameters are inappropriate for this signature engine

### clone

    public Object clone()
                 throws CloneNotSupportedException

  Returns a clone if the implementation is cloneable.
  Overrides:
    `clone` in class `Object`
  Returns:
    a clone if the implementation is cloneable.
  Throws:
    `CloneNotSupportedException` - if this is called on an implementation that does not support `Cloneable`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >